<?php

class Woodpecker_Customizer {

    public static function Woodpecker_Register($wp_customize) {
        self::Woodpecker_Sections($wp_customize);
        self::Woodpecker_Controls($wp_customize);
    }

    public static function Woodpecker_Sections($wp_customize) {
        /*         * s
         * General Section
         */
        $wp_customize->add_section('general_setting_section', array(
            'title' => __('General Settings', 'woodpecker'),
            'description' => __('Allows you to customize header logo, favicon, background etc settings for Woodpecker Theme.', 'woodpecker'), //Descriptive tooltip
            'panel' => '',
            'priority' => '10',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Home Page Top Feature Area
         */
        $wp_customize->add_section('home_top_feature_area', array(
            'title' => __('Top Feature Area', 'woodpecker'),
            'description' => __('Allows you to setup Top feature area section for Woodpecker Theme.', 'woodpecker'), //Descriptive tooltip
            'panel' => '',
            'priority' => '11',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Home Page Feature area setting
         */
        $wp_customize->add_section('home_page_blog_headings', array(
            'title' => __('Featured Punchline', 'woodpecker'),
            'description' => __('Allows you to setup Featured Punchline Section for Woodpecker Theme.', 'woodpecker'),
            'panel' => '',
            'priority' => '12',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Social Icon Section
         */
        $wp_customize->add_section('social_icon_section', array(
            'title' => __('Social Icons', 'woodpecker'),
            'description' => __('Allows you to setup social site link for Woodpecker Theme.', 'woodpecker'),
            'panel' => '',
            'priority' => '13',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Style Section
         */
        $wp_customize->add_section('style_section', array(
            'title' => __('Style Setting', 'woodpecker'),
            'description' => __('Allows you to setup Top Footer Section Text for Woodpecker Theme.', 'woodpecker'),
            'panel' => '',
            'priority' => '14',
            'capability' => 'edit_theme_options'
                )
        );
    }

    public static function Woodpecker_Section_Content() {

        $section_content = array(
            'general_setting_section' => array(
                'woodpecker_headbg',
                'woodpecker_favicon',
                'woodpecker_nav_txt'
            ),
            'home_top_feature_area' => array(
                'woodpecker_slideimage1',
                'woodpecker_sliderheading1',
                'woodpecker_sliderdes1',
                'woodpecker_Slider_butotntext1',
                'woodpecker_Slider_buttonlink1'
            ),
            'home_page_blog_headings' => array(
                'woodpecker_punchline_heading',
                'woodpecker_page_tagline_desc'
            ),
            'style_section' => array(
                'woodpecker_customcss'
            ),
            'social_settings' => array(
                'woodpecker_facebook',
                'woodpecker_twitter',
                'woodpecker_google',
                'woodpecker_rss',
                'woodpecker_pinterest',
                'woodpecker_linkedin'
            )
        );
        return $section_content;
    }

    public static function Woodpecker_Settings() {
        $woodpecker_settings = array(
            'woodpecker_headbg' => array(
                'id' => 'woodpecker_options[woodpecker_headbg]',
                'label' => __('Template Header Background Image', 'woodpecker'),
                'description' => __('Choose a suitable background for template pages header for eg. page, post, attachment. Optimal width is 1600px and height is 250px.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'image',
                'default' => get_template_directory_uri() . '/images/page-top-bg.jpg'
            ),
            'woodpecker_favicon' => array(
                'id' => 'woodpecker_options[woodpecker_favicon]',
                'label' => __('Custom Favicon', 'woodpecker'),
                'description' => __('Here you can upload a Favicon for your Website. Specified size is 16px x 16px.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'image',
                'default' => ''
            ),
            'woodpecker_nav_txt' => array(
                'id' => 'woodpecker_options[woodpecker_nav_txt]',
                'label' => __('Mobile Navigation Menu', 'woodpecker'),
                'description' => __('Enter your mobile navigation menu text.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'text',
                'default' => 'Menu'
            ),
            'woodpecker_slideimage1' => array(
                'id' => 'woodpecker_options[woodpecker_slideimage1]',
                'label' => __('Top Feature Image', 'woodpecker'),
                'description' => __('The optimal size of the image is 1600 px wide x 650 px height, but it can be varied as per your requirement.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'image',
                'default' => get_template_directory_uri() . '/images/slide_1.jpg'
            ),
            'woodpecker_sliderheading1' => array(
                'id' => 'woodpecker_options[woodpecker_sliderheading1]',
                'label' => __('Top Feature Heading', 'woodpecker'),
                'description' => __('Mention the heading for the Top Feature.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('WordPress theme with Bootstrap', 'woodpecker')
            ),
            'woodpecker_Slider_buttonlink1' => array(
                'id' => 'woodpecker_options[woodpecker_Slider_buttonlink1]',
                'label' => __('Link for Top Feature Image', 'woodpecker'),
                'description' => __('Mention the URL for first image.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
            'woodpecker_sliderdes1' => array(
                'id' => 'woodpecker_options[woodpecker_sliderdes1]',
                'label' => __('Top Feature Description', 'woodpecker'),
                'description' => __('Here mention a short description for the Top Feature heading.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('Woodpecker is completely integrated with Bootstrap 3.0', 'woodpecker')
            ),
            'woodpecker_Slider_butotntext1' => array(
                'id' => 'woodpecker_options[woodpecker_Slider_butotntext1]',
                'label' => __('Link Text for Top Feature', 'woodpecker'),
                'description' => __('Mention the link text for top Feature Image', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('Read More', 'woodpecker')
            ),
            'woodpecker_punchline_heading' => array(
                'id' => 'woodpecker_options[woodpecker_punchline_heading]',
                'label' => __('Featured Punchline Heading', 'woodpecker'),
                'description' => __('Mention the punch line heading for your business here.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('Build Your Clean & Optimized Website Within Few Clicks', 'woodpecker')
            ),
            'woodpecker_page_tagline_desc' => array(
                'id' => 'woodpecker_options[woodpecker_page_tagline_desc]',
                'label' => __('Featured Tagline Description', 'woodpecker'),
                'description' => __('Mention the tagline for your business here that will complement the punch line.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('Creating your website with Woodpecker is completely easy. You just need to perform few tweaks in the theme option panel and your website will be ready to use. You can showcase all important aspects of your business here on home page.', 'woodpecker')
            ),
            'woodpecker_customcss' => array(
                'id' => 'woodpecker_options[woodpecker_customcss]',
                'label' => __('Custom CSS', 'woodpecker'),
                'description' => __('Quickly add your custom CSS code to your theme by writing the code in this block.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => ''
            ),
            'woodpecker_facebook' => array(
                'id' => 'woodpecker_options[woodpecker_facebook]',
                'label' => __('Facebook URL', 'woodpecker'),
                'description' => __('Mention the URL of your Facebook here.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
            'woodpecker_twitter' => array(
                'id' => 'woodpecker_options[woodpecker_twitter]',
                'label' => __('Twitter URL', 'woodpecker'),
                'description' => __('Mention the URL of your Twitter here.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
            'woodpecker_google' => array(
                'id' => 'woodpecker_options[woodpecker_google]',
                'label' => __('Google+ URL', 'woodpecker'),
                'description' => __('Mention the URL of your Google+ here.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
            'woodpecker_rss' => array(
                'id' => 'woodpecker_options[woodpecker_rss]',
                'label' => __('Rss Feed URL', 'woodpecker'),
                'description' => __('Mention the URL of your Rss Feed here.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
            'woodpecker_pinterest' => array(
                'id' => 'woodpecker_options[woodpecker_pinterest]',
                'label' => __('Pinterest URL', 'woodpecker'),
                'description' => __('Mention the URL of your Pinterest here.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
            'woodpecker_linkedin' => array(
                'id' => 'woodpecker_options[woodpecker_linkedin]',
                'label' => __('Linkedin URL', 'woodpecker'),
                'description' => __('Mention the URL of your Linkedin here.', 'woodpecker'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
        );
        return $woodpecker_settings;
    }

    public static function Woodpecker_Controls($wp_customize) {
        $sections = self::Woodpecker_Section_Content();
        $settings = self::Woodpecker_Settings();
        foreach ($sections as $section_id => $section_content) {
            foreach ($section_content as $section_content_id) {
                switch ($settings[$section_content_id]['setting_type']) {
                    case 'image':
                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodpecker_sanitize_url');
                        $wp_customize->add_control(new WP_Customize_Image_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id']
                                )
                        ));
                        break;
                    case 'text':
                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodpecker_sanitize_text');
                        $wp_customize->add_control(new WP_Customize_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id'],
                            'type' => 'text'
                                )
                        ));
                        break;
                    case 'textarea':
                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodpecker_sanitize_textarea');

                        $wp_customize->add_control(new WP_Customize_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id'],
                            'type' => 'textarea'
                                )
                        ));
                        break;
                    case 'link':

                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodpecker_sanitize_url');

                        $wp_customize->add_control(new WP_Customize_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id'],
                            'type' => 'text'
                                )
                        ));

                        break;
                    default:
                        break;
                }
            }
        }
    }

    public static function add_setting($wp_customize, $setting_id, $default, $type, $sanitize_callback) {
        $wp_customize->add_setting($setting_id, array(
            'default' => $default,
            'capability' => 'edit_theme_options',
            'sanitize_callback' => array('Woodpecker_Customizer', $sanitize_callback),
            'type' => $type
                )
        );
    }

    /**
     * adds sanitization callback funtion : textarea
     * @package Woodpecker
     */
    public static function woodpecker_sanitize_textarea($value) {
        $array = wp_kses_allowed_html('post');
        $allowedtags = array(
            'iframe' => array(
                'width' => array(),
                'height' => array(),
                'frameborder' => array(),
                'scrolling' => array(),
                'src' => array(),
                'marginwidth' => array(),
                'marginheight' => array()
            )
        );
        $data = array_merge($allowedtags, $array);
        $value = wp_kses($value, $data);
        return $value;
    }

    /**
     * adds sanitization callback funtion : url
     * @package Woodpecker
     */
    public static function woodpecker_sanitize_url($value) {
        $value = esc_url($value);
        return $value;
    }

    /**
     * adds sanitization callback funtion : text
     * @package Woodpecker
     */
    public static function woodpecker_sanitize_text($value) {
        $value = sanitize_text_field($value);
        return $value;
    }

    /**
     * adds sanitization callback funtion : email
     * @package Woodpecker
     */
    public static function woodpecker_sanitize_email($value) {
        $value = sanitize_email($value);
        return $value;
    }

    /**
     * adds sanitization callback funtion : number
     * @package Woodpecker
     */
    public static function woodpecker_sanitize_number($value) {
        $value = preg_replace("/[^0-9+ ]/", "", $value);
        return $value;
    }

}

// Setup the Theme Customizer settings and controls...
add_action('customize_register', array('Woodpecker_Customizer', 'Woodpecker_Register'));

function inkthemes_registers() {
    wp_register_script('inkthemes_jquery_ui', '//code.jquery.com/ui/1.11.0/jquery-ui.js', array("jquery"), true);
    wp_register_script('inkthemes_customizer_script', get_template_directory_uri() . '/functions/js/inkthemes_customizer.js', array("jquery", "inkthemes_jquery_ui"), true);
    wp_enqueue_script('inkthemes_customizer_script');
    wp_localize_script('inkthemes_customizer_script', 'ink_advert', array(
        'pro' => __('View PRO version', 'woodpecker'),
        'url' => esc_url('http://www.inkthemes.com/wp-themes/professional-wordpress-theme/'),
        'support_text' => __('Need Help!', 'woodpecker'),
        'support_url' => esc_url('http://www.inkthemes.com/lets-connect/')
            )
    );
}

add_action('customize_controls_enqueue_scripts', 'inkthemes_registers');
